//Very Tiny Square
//version 1
//By Sparr
//(c) 2004 Clarence Risher
//sparr0@gmail.com
//Released under the GNU GPL, latest version available at http://www.gnu.org/licenses/gpl.txt

#define NO_CALC_DETECT
#include <tigcclib.h>
#undef __need_in_use_bit
#define __need_in_use_bit ((void)0)
#include "extgraph.h"

register short pax asm("d4"), pay asm("d5"), pbx asm("d6"), pby asm("d7");

void XORPix(short x, short y) {
	EXT_XORPIX(LCD_MEM,x,y);
}

short collide() {
	return EXT_GETPIX(LCD_MEM,pax,pay)?1:EXT_GETPIX(LCD_MEM,pbx,pby)?2:0;
}

// Main Function
void _main(void)
{
	short pad, pbd;
	INT_HANDLER save_int_1, save_int_5;
	short timer,keys,x;

	restart:

	save_int_1 = GetIntVec (AUTO_INT_1);
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
	SetIntVec (AUTO_INT_5, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
	
	
	ClrScr();
	
	pax=20;
	pay=60;
	pbx=140;
	pby=20;
	pad=0;
	pbd=2;

	for(x=160;x--;) {
		XORPix(x,0);
		XORPix(x,79);
	}
	for(x=80;x--;) {
		XORPix(0,x);
		XORPix(159,x);
	}

	while(1){
		if(collide()) break;
		XORPix(pax,pay);
		XORPix(pbx,pby);
		for(timer=1000;timer--;) {
			if((keys=_rowread(~0b100001))) {
				if((keys>>0)&1) {
					pbd=1;
				}
				if((keys>>1)&1) {
					pbd=2;
				}
				if((keys>>2)&1) {
					pbd=3;
				}
				if((keys>>3)&1) {
					pbd=0;
				}
				if((keys>>4)&1) {
					pad=2;
				}
				if((keys>>5)&1) {
					pad=0;
				}
				if((keys>>6)&1) {
					pad=3;
				}
				if((keys>>7)&1) {
					pad=1;
				}
			}
		}
		pax+=(!(pad&1))*(1-pad);
		pay+=(pad&1)*(pad-2);
		pbx+=(!(pbd&1))*(1-pbd);
		pby+=(pbd&1)*(pbd-2);
	}

	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5, save_int_5);

	if(DlgMessage("Play Again?",collide()-1?"Player 1 Wins":"Player 2 Wins",BT_YES,BT_NO)==KEY_ENTER)
		goto restart;
	
}
